searchNodes=[{"doc":"A category (or tags) based logger for Elixir. Logbook is a wrapper aroud Elixir Logger that enables a to specify one or more tags for each invocation in order to be able to set different log levels for each tag. Tagging logs is useful to track log informations around different modules and enable only one (or more) specific tags at different log levels than the default Logger instead of having (for example) all debug logs enabled. In the following example when calling delete_all and having the :audit tag level set to at least :info , both &quot;Deleting user...&quot; and &quot;Deleting domain&quot; logs will be produced. If only :domain or :user tags have log level set to :info only the corresponding logs will be produced. ## Example require Logbook def delete_user ( user ) do Logbook . info ( [ :audit , :user ] , &quot;Deleting user \#{ inspect ( user ) } &quot; ) # ... end def delete_domain ( domain ) do Logbook . info ( [ :audit , :domain ] , &quot;Deleting domain \#{ inspect ( domain ) } &quot; ) # ... end def delete_all ( user , domain ) do delete_domain ( domain ) delete_user ( user ) end Log levels for each tag can be set using Logbook.set_level/2 : # For a single tag Logbook . set_level ( :audit , :info ) # or for many tags at once Logbook . set_level ( [ :audit , :user , :domain ] , :info ) Is possible to set the default level for all tags, by setting the :default_tag_level config option for :logbook app (defaults to :warning ): import Config config :logbook , :default_tag_level , :warning The :default_tag_level option is used when Logbook sees tags for the first time during runtime and set them internally with the above level. As a bonus, Logbook also creates a module-level tag automatically, in order to be able to enable log statements at once in a single module: defmodule Foo require Logbook def delete_user ( user ) do Logbook . info ( [ :audit , :user ] , &quot;Deleting user \#{ inspect ( user ) } &quot; ) # ... end def delete_domain ( domain ) do Logbook . info ( [ :audit , :domain ] , &quot;Deleting domain \#{ inspect ( domain ) } &quot; ) # ... end end With the above example is possible to Logbook.set_level(Foo, :info) to enable all Logbook calls inside the module Foo . As with :default_tag_level is possible to set also default module-level logging with: import Config config :logbook , :default_module_level , :warning By default :default_module_level is set to :none (no module-level logging). Logbook supports all Logger levels, along with the additional :none level that disables it for the specified tag/module. Being a wrapper for Logger , if the Logger log level is less that Logbook log level, the logs will not be produced, because are filtered by Logger log levels. Example: Logger . configure ( level : :warning ) Logbook . set_level ( :foo , :debug ) Logbook . debug ( :foo , &quot;This will not be emitted&quot; )","ref":"Logbook.html","title":"Logbook","type":"module"},{"doc":"","ref":"Logbook.html#alert/3","title":"Logbook.alert/3","type":"macro"},{"doc":"","ref":"Logbook.html#critical/3","title":"Logbook.critical/3","type":"macro"},{"doc":"","ref":"Logbook.html#debug/3","title":"Logbook.debug/3","type":"macro"},{"doc":"","ref":"Logbook.html#emergency/3","title":"Logbook.emergency/3","type":"macro"},{"doc":"Checks wheter the tag has the specified log level equal o higher than the configured one. iex&gt; Logbook . set_level ( :foo , :info ) :ok iex&gt; Logbook . enabled? ( :foo , :debug ) false iex&gt; Logbook . enabled? ( :foo , :warning ) true If a list of tags is passed, returns true if any of the tag log level is equal or lower than the passed one.","ref":"Logbook.html#enabled?/2","title":"Logbook.enabled?/2","type":"function"},{"doc":"","ref":"Logbook.html#error/3","title":"Logbook.error/3","type":"macro"},{"doc":"","ref":"Logbook.html#info/3","title":"Logbook.info/3","type":"macro"},{"doc":"Like enabled?/2 checks if the given module has a configured log level equal or lower than the given level.","ref":"Logbook.html#module_enabled?/2","title":"Logbook.module_enabled?/2","type":"function"},{"doc":"","ref":"Logbook.html#notice/3","title":"Logbook.notice/3","type":"macro"},{"doc":"","ref":"Logbook.html#reset/0","title":"Logbook.reset/0","type":"function"},{"doc":"Sets log level for the specific tag or list of tags.","ref":"Logbook.html#set_level/2","title":"Logbook.set_level/2","type":"function"},{"doc":"Returns a map containing the tags/modules seen at runtime with the corresponding configured log level. This list is built at runtime, so if a Logbook loggin fun has never be called, the corresponding tag will not be shown here.","ref":"Logbook.html#tags/0","title":"Logbook.tags/0","type":"function"},{"doc":"","ref":"Logbook.html#warn/3","title":"Logbook.warn/3","type":"macro"},{"doc":"","ref":"Logbook.html#warning/3","title":"Logbook.warning/3","type":"macro"},{"doc":"","ref":"Logbook.html#t:level/0","title":"Logbook.level/0","type":"type"},{"doc":"","ref":"Logbook.html#t:tag_or_tags/0","title":"Logbook.tag_or_tags/0","type":"type"},{"doc":"Log format file based backend. This backend is opinionated for optimal support of Logbook tagged logging, so a tags entry is always added even if no tags (ie called by plain Logger) are given. This backend cannot be configured, all metadata is always logged, along with additional fields. Here is an example of how to configure the Logfmt backend in a config/config.exs file: # Configures Elixir&#39;s Logger config :logger , backends : [ :console , { Logbook.Backends.Logfmt , :log_fmt_log } ] # Log formar file log config :logger , :log_fmt_log , path : &quot;/var/log/somefile.log&quot;","ref":"Logbook.Backends.Logfmt.html","title":"Logbook.Backends.Logfmt","type":"module"}]